/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 2a
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"

int main (void)
{
  uint8_t ledState;

  //Set LED1 pin as an output
  GPIOSetDir( LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);

  //Set SW2 pin as an input
  GPIOSetDir( SW2_PORT, SW2_PIN, GPIO_INPUT);

  //Extra, turn buzzer off (PIO0_7 = high), if soldered to pcb
  GPIOSetDir( PORT0, 7, GPIO_OUTPUT);
  GPIOSetValue( PORT0, 7, 1);

  //enter forever loop
  while (1)
  {
    //Check if push-button is pressed
    if ( (SW2_PORT_REG & (1 << SW2_PIN)) == SW_PRESSED)
      ledState = LED_ON;
    else
      ledState = LED_OFF;

    //Control LED
    GPIOSetValue( LED1_PORT, LED1_PIN, ledState);
  }

  return 0;
}
