/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 2c
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"


int main (void)
{
  uint8_t ledState;
  uint8_t buzzerState;

  //Set LED1 pin as an output
  GPIOSetDir( LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);

  //Set SW2 pin as an input
  GPIOSetDir( SW2_PORT, SW2_PIN, GPIO_INPUT);

  //Extra, turn buzzer off
  GPIOSetDir( BUZZ_PORT, BUZZ_PIN, GPIO_OUTPUT);
  GPIOSetValue( BUZZ_PORT, BUZZ_PIN, BUZZ_OFF);

  //enter forever loop
  while (1)
  {
    //Check if both push-buttons are pressed
    if ( (GPIOGetValue(SW2_PORT, SW2_PIN) == SW_PRESSED) &&
    	 (GPIOGetValue(SW3_PORT, SW3_PIN) == SW_PRESSED))
    {
      buzzerState = BUZZ_ON;
      ledState = LED_ON;
    }
    else
    {
      buzzerState = BUZZ_OFF;
      ledState = LED_OFF;
    }

    //Control LED
    GPIOSetValue( LED1_PORT, LED1_PIN, ledState);

    //Control buzzer
    GPIOSetValue( BUZZ_PORT, BUZZ_PIN, buzzerState);
  }

  return 0;
}
