/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 2d
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"

int
main(void)
{
  uint8_t ledState;

  //Set LED1 pin as an output
  GPIOSetDir(LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue(LED1_PORT, LED1_PIN, LED_OFF);

  //Set SW2 pin as an input
  GPIOSetDir(SW2_PORT, SW2_PIN, GPIO_INPUT);

  //Extra, turn buzzer off
  GPIOSetDir(BUZZ_PORT, BUZZ_PIN, GPIO_OUTPUT);
  GPIOSetValue(BUZZ_PORT, BUZZ_PIN, BUZZ_OFF);

  //enter forever loop
  while (1)
  {
    //check if push-button is pressed
    if (GPIOGetValue(SW2_PORT, SW2_PIN) == SW_PRESSED)
    {
      //toggle LED
      if (ledState == LED_ON)
        ledState = LED_OFF;
      else
        ledState = LED_ON;
      GPIOSetValue(LED1_PORT, LED1_PIN, ledState);

      //wait until push-button is released
      while (GPIOGetValue(SW2_PORT, SW2_PIN) == SW_PRESSED)
        ;
//	  delayMS(50);  //will solve problem with contact bounce
    }
  }
  return 0;
}
