/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 5d
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"
#include "adc.h"
#include "string.h"
#include <stdio.h>

uint32_t adcBuffer[1024];

int main (void)
{
  uint32_t i, outOfBounds;
  uint16_t firstIndex, lastIndex, adcVal;

  //Set LED1-LED8 pins as outputs
  GPIOSetDir( LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);
  GPIOSetDir( LED2_PORT, LED2_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED2_PORT, LED2_PIN, LED_OFF);
  GPIOSetDir( LED3_PORT, LED3_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED3_PORT, LED3_PIN, LED_OFF);
  GPIOSetDir( LED4_PORT, LED4_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED4_PORT, LED4_PIN, LED_OFF);
  GPIOSetDir( LED5_PORT, LED5_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED5_PORT, LED5_PIN, LED_OFF);
  GPIOSetDir( LED6_PORT, LED6_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED6_PORT, LED6_PIN, LED_OFF);
  GPIOSetDir( LED7_PORT, LED7_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED7_PORT, LED7_PIN, LED_OFF);
  GPIOSetDir( LED8_PORT, LED8_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED8_PORT, LED8_PIN, LED_OFF);

  //Set SW2/SW3 pins as inputs
  GPIOSetDir( SW2_PORT, SW2_PIN, GPIO_INPUT);
  GPIOSetDir( SW3_PORT, SW3_PIN, GPIO_INPUT);

  //Extra, turn buzzer off
  GPIOSetDir( BUZZ_PORT, BUZZ_PIN, GPIO_OUTPUT);
  GPIOSetValue( BUZZ_PORT, BUZZ_PIN, BUZZ_OFF);

  printf("\nThis program reads AIN0 repeatedly...\n");

  //Initialize ADC peripheral and pin-mixing
  ADCInit(4500000);  //4.5MHz ADC clock

  //get initial value (could be 0 also)
  getADC(AIN0);

  memset(adcBuffer, 0, 1024*4);
  outOfBounds = 0;
  for(i=0; i<1000000; i++)
  {
    adcVal = getADC(AIN0);
    if (adcVal <= 1023)
      adcBuffer[adcVal]++;
    else
      outOfBounds++;

  }

  //find first non-zero entry
  i = 0;
  while(adcBuffer[i++] == 0);
  if (i>0)
    firstIndex = i-1;
  else
    firstIndex = 0;

  //find first non-zero entry
  i = 1023;
  while(adcBuffer[i--] == 0);
  lastIndex = i+1;
  if (lastIndex > 1023)
    lastIndex = 1023;

  printf("\nValue: number of samples");
  for(i=firstIndex; i<=lastIndex; i++)
    printf("\n %4d: %d", i, adcBuffer[i]);

  printf("\n\nInvalid results: %d", outOfBounds);

  while(1);

  return 0;
}
