/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 11a
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"
#include "adc.h"
#include "pwm.h"
#include "spi.h"

#define MAGIC_CONSTANT  0x52

/*
 * Note that this experiment will not work after the components
 * have been soldered to the experiment board.
 */

int main (void)
{
  //Set LED1-LED8 pins as outputs
  GPIOSetDir( LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);
  GPIOSetDir( LED2_PORT, LED2_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED2_PORT, LED2_PIN, LED_OFF);
  GPIOSetDir( LED3_PORT, LED3_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED3_PORT, LED3_PIN, LED_OFF);
  GPIOSetDir( LED4_PORT, LED4_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED4_PORT, LED4_PIN, LED_OFF);
  GPIOSetDir( LED5_PORT, LED5_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED5_PORT, LED5_PIN, LED_OFF);
  GPIOSetDir( LED6_PORT, LED6_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED6_PORT, LED6_PIN, LED_OFF);
  GPIOSetDir( LED7_PORT, LED7_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED7_PORT, LED7_PIN, LED_OFF);
  GPIOSetDir( LED8_PORT, LED8_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED8_PORT, LED8_PIN, LED_OFF);

  //Set SW2/SW3 pins as inputs
  GPIOSetDir( SW2_PORT, SW2_PIN, GPIO_INPUT);
  GPIOSetDir( SW3_PORT, SW3_PIN, GPIO_INPUT);

  //Extra, turn buzzer pin to input
  GPIOSetDir( BUZZ_PORT, BUZZ_PIN, GPIO_OUTPUT);
  GPIOSetValue( BUZZ_PORT, BUZZ_PIN, BUZZ_OFF);

  SSP0Init(1500000);

  //Handle SSEL signal - note: same as LED1, so technically not needed to do this
  GPIOSetDir( SSEL_GPIO_4_PORT, SSEL_GPIO_4_PIN, GPIO_OUTPUT);
  GPIOSetValue( SSEL_GPIO_4_PORT, SSEL_GPIO_4_PIN, 1);

  while(1)
  {
      uint8_t charOfInterest;

      charOfInterest = MAGIC_CONSTANT;

      GPIOSetValue( SSEL_GPIO_4_PORT, SSEL_GPIO_4_PIN, SSEL_LOW);
      SSP0Send( &charOfInterest, 1 );
      GPIOSetValue( SSEL_GPIO_4_PORT, SSEL_GPIO_4_PIN, SSEL_HIGH);

      delayMS(1);

      GPIOSetValue( SSEL_GPIO_4_PORT, SSEL_GPIO_4_PIN, SSEL_LOW);
      SSP0Receive( &charOfInterest, 1 );
      GPIOSetValue( SSEL_GPIO_4_PORT, SSEL_GPIO_4_PIN, SSEL_HIGH);

      if (charOfInterest == MAGIC_CONSTANT)
      {
        //flash LED
        while(1)
        {
          GPIOSetValue( LED8_PORT, LED8_PIN, LED_ON);
          delayMS(50);
          GPIOSetValue( LED8_PORT, LED8_PIN, LED_OFF);
          delayMS(50);
        }
      }
      else
      {
        //turn LED on
        GPIOSetValue( LED8_PORT, LED8_PIN, LED_ON);
        while(1);
      }
  }

  return 0;
}
