/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 12c
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"
#include "adc.h"
#include "pwm.h"
#include "spi.h"
#include "timerCB.h"

/*****************************************************************************
** Function name:    toggleLED
** Descriptions:     This function toggles output PIO0_2
** Parameters:       None
** Returned value:   None
**
*****************************************************************************/
void toggleLED(void)
{
  static uint8_t ledState;

  /* toggle LED on PIO0_2 */
  if (ledState == 0)
  {
    ledState = 1;

    /* set LED */
    GPIOSetValue( LED1_PORT, LED1_PIN, LED_ON);
  }
  else
  {
    ledState = 0;

    /* set LED */
    GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);
  }
}

int main (void)
{
  //Set LED1-LED8 pins as outputs
  GPIOSetDir( LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);
  GPIOSetDir( LED2_PORT, LED2_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED2_PORT, LED2_PIN, LED_OFF);
  GPIOSetDir( LED3_PORT, LED3_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED3_PORT, LED3_PIN, LED_OFF);
  GPIOSetDir( LED4_PORT, LED4_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED4_PORT, LED4_PIN, LED_OFF);
  GPIOSetDir( LED5_PORT, LED5_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED5_PORT, LED5_PIN, LED_OFF);
  GPIOSetDir( LED6_PORT, LED6_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED6_PORT, LED6_PIN, LED_OFF);
  GPIOSetDir( LED7_PORT, LED7_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED7_PORT, LED7_PIN, LED_OFF);
  GPIOSetDir( LED8_PORT, LED8_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED8_PORT, LED8_PIN, LED_OFF);

  //Set SW2/SW3 pins as inputs
  GPIOSetDir( SW2_PORT, SW2_PIN, GPIO_INPUT);
  GPIOSetDir( SW3_PORT, SW3_PIN, GPIO_INPUT);

  //Extra, turn buzzer pin to input
  GPIOSetDir( BUZZ_PORT, BUZZ_PIN, GPIO_OUTPUT);
  GPIOSetValue( BUZZ_PORT, BUZZ_PIN, BUZZ_OFF);

#if 0

  /* register callback (to toggle LED) in 200ms */
  registerCbAndDelay(200, TRUE, &toggleLED);

  while(1);

#else

  /* enter forever loop – let interrupt handle processing */
  while(1)
  {
    /* register callback (to toggle LED) in 200ms */
    registerCbAndDelay(200, FALSE, &toggleLED);

    /* wait until callback has been called */
    while (checkIfCbActive() == TRUE)
      ;
  }
#endif
  return 0;
}
