/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 13c
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "stdio.h"
#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"
#include "adc.h"
#include "pwm.h"
#include "spi.h"
#include "timerCB.h"
#include "i2c.h"
#include "pca9532.h"

int main (void)
{
  uint8_t i, j;

  //Set LED1-LED8 pins as outputs
  GPIOSetDir( LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);
  GPIOSetDir( LED2_PORT, LED2_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED2_PORT, LED2_PIN, LED_OFF);
  GPIOSetDir( LED3_PORT, LED3_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED3_PORT, LED3_PIN, LED_OFF);
  GPIOSetDir( LED4_PORT, LED4_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED4_PORT, LED4_PIN, LED_OFF);
  GPIOSetDir( LED5_PORT, LED5_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED5_PORT, LED5_PIN, LED_OFF);
  GPIOSetDir( LED6_PORT, LED6_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED6_PORT, LED6_PIN, LED_OFF);
  GPIOSetDir( LED7_PORT, LED7_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED7_PORT, LED7_PIN, LED_OFF);
  GPIOSetDir( LED8_PORT, LED8_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED8_PORT, LED8_PIN, LED_OFF);

  //Set SW2/SW3 pins as inputs
  GPIOSetDir( SW2_PORT, SW2_PIN, GPIO_INPUT);
  GPIOSetDir( SW3_PORT, SW3_PIN, GPIO_INPUT);

  //Extra, turn buzzer pin to input
  GPIOSetDir( BUZZ_PORT, BUZZ_PIN, GPIO_OUTPUT);
  GPIOSetValue( BUZZ_PORT, BUZZ_PIN, BUZZ_OFF);

  /* initialize I2C as needed */
  I2CInit( I2CMASTER, 0 );

  /*
   * Setup for demonstrating dimming via PCA9532
   */
  pca9532_setBlink0Period(0);   //Set PWM frequency to 152 Hz
  pca9532_setBlink0Leds(0x20);  //Dim LED3

  for(j=0; j<3; j++)
  {
    for(i=0; i<100; i++)
    {
      pca9532_setBlink0Duty(i);
      delayMS(5);
    }
    for(i=100; i>0; i--)
    {
      pca9532_setBlink0Duty(i);
      delayMS(5);
    }
  }

  //enter forever loop
  while(1)
  {
    uint8_t i;

    for(i=0; i<8; i++)
    {
      pca9532_setLeds( (1<<i), ~(1<<i) );
      delayMS(50);
    }

  }

  return 0;
}
