/*****************************************************************************
 *   Placeholder for timer callback related functions.
 *   Part of the proposed solutions for LPCXpresso Experiment Kit
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/
#ifndef __TIMERCB_H__
#define __TIMERCB_H__

#include "type.h"

/*****************************************************************************
** Function name:    registerCbAndDelay
** Descriptions:     This function setup 32-bit timer #1 to generate
**                   an interrupt after specified time and then call a
**                   registered callback function.
** parameters:       delay in ms and callback function pointer
** Returned value:   None
**
*****************************************************************************/
void registerCbAndDelay( uint16_t delayInMS, uint8_t repeat, void (*pF)(void));

/*****************************************************************************
** Function name:    checkIfCbActive
** Descriptions:     This function checks if the callback is active
** parameters:       None
** Returned value:   TRUE if callback is active, else FLASE
**
*****************************************************************************/
uint8_t checkIfCbActive( void );

/*****************************************************************************
** Function name:    stopCb
** Descriptions:     This function stops a repeat-callback
** parameters:       None
** Returned value:   None
**
*****************************************************************************/
void stopCb( void );

#endif /* __TIMERCB_H__ */
