/*****************************************************************************
 *   Placeholder for LM75 related functions.
 *   Part of the proposed solutions for LPCXpresso Experiment Kit
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/
#ifndef __LM75_H__
#define __LM75_H__

#include "type.h"

/******************************************************************************
 *
 * Description:
 *    Read temperature register of LM75B
 *
 * Params:  None
 * Returns: Temperature * 100 in integer format
 *
 *****************************************************************************/
int32_t lm75b_readTemp(void);

/******************************************************************************
 *
 * Description:
 *    Write to config register of LM75B
 *
 * Params:  Config byte
 * Returns: None
 *
 *****************************************************************************/
void lm75b_config(int8_t config);

#endif /* __LM75_H__ */
