/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 14a
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "stdio.h"
#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"
#include "adc.h"
#include "pwm.h"
#include "spi.h"
#include "timerCB.h"
#include "i2c.h"
#include "pca9532.h"
#include "uart.h"

int main (void)
{
  uint8_t buf[20];

  //Set LED1-LED8 pins as outputs
  GPIOSetDir( LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);
  GPIOSetDir( LED2_PORT, LED2_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED2_PORT, LED2_PIN, LED_OFF);
  GPIOSetDir( LED3_PORT, LED3_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED3_PORT, LED3_PIN, LED_OFF);
  GPIOSetDir( LED4_PORT, LED4_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED4_PORT, LED4_PIN, LED_OFF);
  GPIOSetDir( LED5_PORT, LED5_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED5_PORT, LED5_PIN, LED_OFF);
  GPIOSetDir( LED6_PORT, LED6_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED6_PORT, LED6_PIN, LED_OFF);
  GPIOSetDir( LED7_PORT, LED7_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED7_PORT, LED7_PIN, LED_OFF);
  GPIOSetDir( LED8_PORT, LED8_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED8_PORT, LED8_PIN, LED_OFF);

  //Set SW2/SW3 pins as inputs
  GPIOSetDir( SW2_PORT, SW2_PIN, GPIO_INPUT);
  GPIOSetDir( SW3_PORT, SW3_PIN, GPIO_INPUT);

  //Extra, turn buzzer pin to input
  GPIOSetDir( BUZZ_PORT, BUZZ_PIN, GPIO_OUTPUT);
  GPIOSetValue( BUZZ_PORT, BUZZ_PIN, BUZZ_OFF);

  //initialize the UART to 9600bps 8N1
  UARTInit(9600);

  UARTSendString((uint8_t*)"\nThis is a echo-application");
  buf[0]  = ' ';
  buf[1]  = 'a';
  buf[2]  = 'n';
  buf[3]  = 'd';
  buf[4]  = ' ';
  buf[5]  = 'i';
  buf[6]  = 't';
  buf[7]  = ' ';
  buf[8]  = 's';
  buf[9]  = 't';
  buf[10] = 'a';
  buf[11] = 'r';
  buf[12] = 't';
  buf[13] = 's';
  buf[14] = '.';
  buf[15] = '.';
  buf[16] = '.';
  UARTSendBuffer(buf, 17);

  //enter forever loop - uart echo application
  while(1)
  {
    uint8_t rxChar;

    //check if char has been received
    if (UARTReceive(&rxChar, 1, FALSE) == 1)
    {
#if 0
      UARTSendChar(rxChar);
#else
      buf[0]  = '\n';
      buf[1]  = 'R';
      buf[2]  = 'e';
      buf[3]  = 'c';
      buf[4]  = 'e';
      buf[5]  = 'i';
      buf[6]  = 'v';
      buf[7]  = 'e';
      buf[8]  = 'd';
      buf[9]  = ':';
      buf[10] = ' ';
      buf[11] = rxChar;
      UARTSendBuffer(buf, 12);
#endif
    }
  }

  return 0;
}
