/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 15b
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "stdio.h"
#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"
#include "adc.h"
#include "pwm.h"
#include "spi.h"
#include "timerCB.h"
#include "i2c.h"
#include "pca9532.h"
#include "uart.h"
#include "gps.h"

void displayGpsData(const gpsData const * pData)
{
	//Time
	printf("\n%s\n", pData->utcTime);

	//Latitude (in ddmmmmmm format, convert to dd.mmmmmm)
	printf("Latitude: %d.%06d\n", pData->latitude/1000000, pData->latitude%1000000);

	//Longitude (in ddmmmmmm format, convert to dd.mmmmmm)
	printf("Longitude: %d.%06d\n", pData->longitude/1000000, pData->longitude%1000000);

	//Number of satellites in view
	printf("#Satellites: %s\n", pData->satellitesUsed);

}
int main (void)
{
  //Set LED1-LED8 pins as outputs
  GPIOSetDir( LED1_PORT, LED1_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED1_PORT, LED1_PIN, LED_OFF);
  GPIOSetDir( LED2_PORT, LED2_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED2_PORT, LED2_PIN, LED_OFF);
  GPIOSetDir( LED3_PORT, LED3_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED3_PORT, LED3_PIN, LED_OFF);
  GPIOSetDir( LED4_PORT, LED4_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED4_PORT, LED4_PIN, LED_OFF);
  GPIOSetDir( LED5_PORT, LED5_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED5_PORT, LED5_PIN, LED_OFF);
  GPIOSetDir( LED6_PORT, LED6_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED6_PORT, LED6_PIN, LED_OFF);
  GPIOSetDir( LED7_PORT, LED7_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED7_PORT, LED7_PIN, LED_OFF);
  GPIOSetDir( LED8_PORT, LED8_PIN, GPIO_OUTPUT);
  GPIOSetValue( LED8_PORT, LED8_PIN, LED_OFF);

  //Set SW2/SW3 pins as inputs
  GPIOSetDir( SW2_PORT, SW2_PIN, GPIO_INPUT);
  GPIOSetDir( SW3_PORT, SW3_PIN, GPIO_INPUT);

  //Extra, turn buzzer pin to input
  GPIOSetDir( BUZZ_PORT, BUZZ_PIN, GPIO_OUTPUT);
  GPIOSetValue( BUZZ_PORT, BUZZ_PIN, BUZZ_OFF);

  //initialize the UART to 9600bps 8N1
  UARTInit(9600);

  printf("\nWaiting for GPS data...");

  //enter forever loop -
  while(1)
  {
	const gpsData* pData = GPSRetreiveData();
	displayGpsData(pData);
	delayMS(1000);
  }

  return 0;
}
