/*****************************************************************************
 *   The proposed solution for LPCXpresso Experiment Kit, Lab 16a
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/

#include "stdio.h"
#include "LPC11xx.h"
#include "type.h"
#include "board.h"
#include "gpio.h"
#include "delay.h"
#include "adc.h"
#include "pwm.h"
#include "spi.h"
#include "timerCB.h"
#include "i2c.h"
#include "pca9532.h"
#include "uart.h"
#include "gps.h"
#include "oled.h"

static void rainbow(draw_lcd_t *lcd)
{
  // White => 0~15
  draw_fillRectangle(lcd, 0, 0, 15, 127, 0xffff);

  // Yellow => 16~31
  draw_fillRectangle(lcd, 16, 0, 31, 127, 0xffe0);

  // Purple => 32~47
  draw_fillRectangle(lcd, 32, 0, 47, 127, 0xf81f);

  // Cyan => 48~63
  draw_fillRectangle(lcd, 48, 0, 63, 127, 0x07ff);

  // Red => 64~79
  draw_fillRectangle(lcd, 64, 0, 79, 127, 0xF800);

  // Green => 80~95
  draw_fillRectangle(lcd, 80, 0, 95, 127, 0x07E0);

  // Blue => 96~111
  draw_fillRectangle(lcd, 96, 0, 111, 127, 0x001f);

  // Black => 112~127
  draw_fillRectangle(lcd, 112, 0, 127, 127, 0x0000);
}


int main (void)
{
  draw_lcd_t lcd;

  // outputs
  GPIOSetDir(OLED_SSEL_PORT, OLED_SSEL_PIN, GPIO_OUTPUT);
  GPIOSetDir(OLED_DC_PORT, OLED_DC_PIN, GPIO_OUTPUT);
  GPIOSetDir(OLED_RESET_PORT, OLED_RESET_PIN, GPIO_OUTPUT);

  GPIOSetValue(OLED_SSEL_PORT, OLED_SSEL_PIN, 1);
  GPIOSetValue(OLED_DC_PORT, OLED_DC_PIN, 1);
  GPIOSetValue(OLED_RESET_PORT, OLED_RESET_PIN, 1);

  SSP0Init(6000000);

  printf("\nInitializing oled driver...");
  oled_init(&lcd);

  rainbow(&lcd);

  //enter forever loop -
  while (1) {
  }

  return 0;
}
